//1_ModelesStyles_403f.js
// 28.01.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//Sert  faire un modle de chaque style de paragraphes et de caractres

if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.");
	exit();
}

// une rfrence au document au premier plan
var curDoc = app.documents[0];

// afficher la premire planche et adapter la page
app.activeWindow.activeSpread = curDoc.spreads[0];
app.activeWindow.zoom(ZoomOptions.fitPage); 

// mettre le point zro  zro/zro
app.documents[0].zeroPoint = [0,0];

// mmoriser le verrouillage des calques et les annuler (si ncessaire)
var allLayers = curDoc.layers;
var nLayers = allLayers.length;
var layerLocks = new Array ();
for (var i=0; i<nLayers; i++) {
	if (allLayers[i].locked == true) {
		allLayers[i].locked = false;
		layerLocks.push(true);
		}
	else {
		layerLocks.push(false);
	}
}

// supprimer les blocs s'ils sont prsents (sinon un message d'erreur 
// sera gnr lors de l'xecution du script qui change les polices)
try {
	curDoc.textFrames.item("paraStyles").remove();
}
catch (e) {
}
try {
	curDoc.textFrames.item("charStyles").remove();
}
catch (e) {
}

// rgler les prfrences des styles
try {
	var eaParaStyle = curDoc.paragraphStyles.item(1);
	var noCharStyle = curDoc.characterStyles.item(0);
	curDoc.textDefaults.appliedParagraphStyle = eaParaStyle;
	curDoc.textDefaults.appliedCharacterStyle = noCharStyle;
}
catch (e) {
}

// relever le format de la page et prparer les paramtres
var pageSize = curDoc.pages[0].bounds;
var y1 = pageSize[0];
var x1 = pageSize[1];
var y2 = pageSize[2];
var x2 = pageSize[3];
var h1 = (y2-y1)/5;

// dfinir une rfrence  la couleur "Papier"
var whiteColor = curDoc.swatches.item("Paper");

// crer un bloc texte, appliquer un nom et la couleur 
var paraFrame = curDoc.pages[0].textFrames.add({geometricBounds:[y1,x1,h1*3,x2], 
	label:"paraStyles", fillColor:whiteColor});

//**********************************
//--- insrer les noms des styles de paragraphes appliquer le style correspondant ---//
var allParaStyles = curDoc.paragraphStyles;
var paraCount = allParaStyles.length;

var paraStory = paraFrame.parentStory;
var paraStyle;
// le premier elment est insr ("1" au lieu de "0"), afin d'viter 
// "Aucun style de paragraphe" qui n'est pas ditable
paraStory.contents = allParaStyles[1].name;
paraStory.paragraphs[0].appliedParagraphStyle = allParaStyles[1];
// une boucle au travers le reste de la liste
for (var i=2; i<paraCount; i++) {
	paraStyle = allParaStyles[i].name;
	paraStory.insertionPoints[-1].contents = "\r" + paraStyle;
	try {
		paraStory.paragraphs.item(i-1).appliedParagraphStyle = paraStyle;
	}
	catch (e) {
	}
}

// crer un bloc texte, appliquer un nom et la couleur 
var charFrame = curDoc.pages[0].textFrames.add({geometricBounds:[h1*3,x1,y2,x2], 
	label:"charStyles", fillColor:whiteColor});

//**********************************
//--- insrer les noms des styles de caractres et appliquer le style correspondant ---//

var allCharStyles = curDoc.characterStyles;
var charCount = allCharStyles.length;
var charStory = charFrame.parentStory;
var charStyle;
// commencer par le deuxime style parce que "Aucun" ne peut pas tre dit
try {
	charStory.contents = allCharStyles[1].name;
	charStory.paragraphs[0].appliedParagraphStyle = eaParaStyle;
	charStory.paragraphs[0].appliedCharacterStyle = allCharStyles[1];
}
catch (e) {
}
// une boucle au travers le reste de la liste
for (var i=2; i<charCount; i++) {
	// s'il n'y pas de police attribue, le style n'est pas list
	if (allCharStyles[i].appliedFont != "") {
		charStyle = allCharStyles[i].name;
		charStory.insertionPoints[-1].contents = "\r" + charStyle;
		try {
			charStory.paragraphs.item(-1).appliedCharacterStyle = charStyle;
		}
		catch (e) {
		}
	}
}

// rtablir le verrouillage des calques (si ncesssaire)
for (var i=0; i<nLayers; i++) {
	allLayers[i].locked = layerLocks[i];
}